#ifndef _SCHODY_H_
#define _SCHODY_H_

#define MAXN 1000

/* Prototypy funkcii */
void Init_game(int *, int *);
void Turn(int, int, int *, int *);

/* Najlepsi hrac, akeho sme boli schopni vymysliet */
int moje_supertajne_pole[MAXN+1];
int moje_supertajne_n;
int moje_supertajne_max;
int initialized=0;

void Init_game(int *n, int *stairs)
 {
  int i;
  if (initialized)
   { printf("You lamma Usama... called Init_game() twice !"); exit(0); }
  moje_supertajne_max=*n=moje_supertajne_n=rand()%MAXN+1;
  stairs[0]=moje_supertajne_pole[0]=47;
  for (i=1;i<=*n;i++) stairs[i]=moje_supertajne_pole[i]=rand()%MAXN+1;
  initialized=1;
 }

void Turn(int from, int coins, int *hisfrom, int* hiscoins)
 {
  if (!initialized)
   { printf("You lamma Usama... forgot to call Init_game() !"); exit(0); }
  if (from<1 || from>moje_supertajne_n)
   { printf("You turn from the wrong stair (%d)\n",from); exit(0); }
  if (coins<=0)
   { printf("You want to take negative amount of coins :-) (%d<=0)\n",coins); exit(0); }
  if (moje_supertajne_pole[from]<coins)
   { printf("You fool, there aren't %d coins, only %d\n",coins,moje_supertajne_pole[from]); exit(0); }
  moje_supertajne_pole[from]-=coins;
  moje_supertajne_pole[from-1]+=coins;
  if (from==moje_supertajne_max)
   while (moje_supertajne_pole[moje_supertajne_max]==0) moje_supertajne_max--;
  if (moje_supertajne_max==0)
   { printf("Congratulations, young Jedi !\n"); exit(0); }

  *hisfrom=moje_supertajne_max;
  *hiscoins=rand()%moje_supertajne_pole[*hisfrom]+1;

  moje_supertajne_pole[*hisfrom]-=*hiscoins;
  moje_supertajne_pole[*hisfrom-1]+=*hiscoins;
  if (*hisfrom==moje_supertajne_max)
   while (moje_supertajne_pole[moje_supertajne_max]==0) moje_supertajne_max--;
  if (moje_supertajne_max==0)
   { printf("Oops, you have lost, young boy...\n"); exit(0); }
 }

#endif /* _SCHODY_H_ */
