unit uStairs;

interface
const MAXN=1000;
type TARRAY=array[0..MAXN] of longint;

procedure Init_game(var n:longint; var stairs:TARRAY);
procedure Turn(from,coins:longint;var hisfrom,hiscoins:longint);

implementation
var moje_supertajne_pole:TARRAY;
var moje_supertajne_n:longint;
var moje_supertajne_max:longint;
var initialized:boolean;

procedure Init_game(var n:longint; var stairs:TARRAY);
 var i:longint;
 begin
  if initialized then
   begin writeln('You lamma, Usama... called Init_game twice!'); halt(0); end;
  moje_supertajne_n:=random(MAXN)+1;
  n:=moje_supertajne_n;
  moje_supertajne_max:=moje_supertajne_n;

  moje_supertajne_pole[0]:=47;
  for i:=1 to n do moje_supertajne_pole[i]:=random(MAXN)+1;
  stairs:=moje_supertajne_pole;
  initialized:=TRUE;
 end;


procedure Turn(from, coins:longint; var hisfrom, hiscoins:longint);
 begin
  if not initialized then
   begin writeln('You lamma :-)  Forgot to call Init_game() !'); halt(0); end;
  if (from<1) or (from>moje_supertajne_n) then
   begin writeln('You turn from the wrong stair (',from,')'); halt(0); end;
  if (coins<=0) then
   begin writeln('You want to take negative amount of coins :-) (',coins,'<=0)'); halt(0); end;
  if (moje_supertajne_pole[from]<coins) then
   begin writeln('You fool, there are not ',coins,' coins, only ',
    moje_supertajne_pole[from]); halt(0); end;
  dec(moje_supertajne_pole[from],coins);
  inc(moje_supertajne_pole[from-1],coins);
  if (from=moje_supertajne_max) then
   while (moje_supertajne_pole[moje_supertajne_max]=0) do dec(moje_supertajne_max);
  if (moje_supertajne_max=0) then
   begin writeln('Congratulations, young Jedi !'); halt(0); end;

  hisfrom:=moje_supertajne_max;
  hiscoins:=random(moje_supertajne_pole[hisfrom])+1;
  dec(moje_supertajne_pole[hisfrom],hiscoins);
  inc(moje_supertajne_pole[hisfrom-1],hiscoins);
  if (hisfrom=moje_supertajne_max) then
   while (moje_supertajne_pole[moje_supertajne_max]=0) do dec(moje_supertajne_max);
  if (moje_supertajne_max=0) then
   begin writeln('Oops, you have lost, young boy...'); halt(0); end;
 end;

 end.
